// 002 u_ado_net_helpers
// 02 feb 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_ado_net_helpers;
  interface
    uses System.Data
        ;

    function f_data_row_action_name(p_data_row_action: DataRowAction): System.String;
    function f_data_row_state_name(p_data_row_state: DataRowState): System.String;
    function f_display_data_row_version_name(p_data_row_version: DataRowVersion): System.String;
    function f_connction_state_name(p_connection_state: ConnectionState): System.String;

    function f_display_data_row(p_c_data_row: DataRow; p_column_count: Integer): System.String;

    function f_display_data_row_version(p_c_data_row: DataRow; p_column_count: Integer;
        p_data_row_version: DataRowVersion): System.String;
    function f_display_data_row_state_version(p_c_data_row: DataRow; p_column_count: Integer): System.String;

    procedure display_data_table(p_c_data_table: DataTable);

    procedure display_data_view(p_c_data_view: DataView; p_column_count: Integer);

  implementation
    uses u_dot_net_types_constants, u_c_dot_net_display
      , u_dot_net_strings
      ;

    function f_data_row_action_name(p_data_row_action: DataRowAction): System.String;
      begin
        Result:= Enum.GetName(TypeOf(DataRowAction), p_data_row_action);
      end; // f_data_row_action_name

    function f_data_row_state_name(p_data_row_state: DataRowState): System.String;
      begin
        Result:= Enum.GetName(TypeOf(DataRowState), p_data_row_state);
      end; // f_data_row_state_name

    function f_display_data_row_version_name(p_data_row_version: DataRowVersion): System.String;
      begin
        Result:= Enum.GetName(TypeOf(DataRowVersion), p_data_row_version);
      end; // f_display_data_row_version_name

    function f_connction_state_name(p_connection_state: ConnectionState): System.String;
      begin
        Result:= Enum.GetName(TypeOf(ConnectionState), p_connection_state);
      end; // f_connction_state_name

    function f_display_data_row(p_c_data_row: DataRow; p_column_count: Integer): System.String;
      var l_column_index: Integer;
      begin
        Result:= '';
        // for l_column_index:= 0 to p_column_count- 1 do
        for l_column_index:= 0 to p_column_count- 1 do
          Result:= Result+ ' '+ p_c_data_row.ItemArray[l_column_index].ToString()

(*
  foreach(DataRow myRow in myTable.Rows){
       foreach(DataColumn myColumn in myTable.Columns){
          Console.WriteLine(myRow[myColumn]);
*)

      end; // f_display_data_row

    function f_display_data_row_version(p_c_data_row: DataRow; p_column_count: Integer;
        p_data_row_version: DataRowVersion): System.String;
      var l_column_index: Integer;
      begin
        Result:= '('+ f_display_data_row_version_name(p_data_row_version)+ ')';
        for l_column_index:= 0 to p_column_count- 1 do
          Result:= Result+ ' '+ p_c_data_row[l_column_index, p_data_row_version].ToString()
      end; // f_display_data_row_version

    function f_display_data_row_state_version(p_c_data_row: DataRow; p_column_count: Integer): System.String;
      var l_column_index: Integer;
          l_current_value, l_proposed_value, l_value: System.String;
      begin
        Result:= System.String.Format('{0} ', p_c_data_row.RowState);

        for l_column_index:= 0 to p_column_count- 1 do
        begin
          if p_c_data_row.HasVersion(DataRowVersion.Current)
            then l_current_value:= p_c_data_row[l_column_index, DataRowVersion.Current].ToString()
            else l_current_value:= '-';

          if p_c_data_row.HasVersion(DataRowVersion.Proposed)
            then l_proposed_value:= p_c_data_row[l_column_index, DataRowVersion.Proposed].ToString()
            else l_proposed_value:= '-';

          l_value:= l_current_value;
          if (l_current_value<> l_proposed_value)
            then l_value:= l_value+ ' [=> '+ l_proposed_value+ ']';

          Result:= Result+ ' '+ l_value;
        end; // vor l_column_index
      end; // f_display_data_row_state_version

    procedure display_data_table(p_c_data_table: DataTable);
      var l_row_index: Integer;
          l_column_index: Integer;
          l_display: String;
      begin
        display_line;
        display('> list_data_table ');

        for l_row_index:= 0 to p_c_data_table.Rows.Count- 1 do
          display(f_display_data_row(p_c_data_table.Rows[l_row_index], p_c_data_table.Columns.Count));
        display('< list_data_table');
      end; // display_data_table

    procedure display_data_view(p_c_data_view: DataView; p_column_count: Integer);
      var l_row_index: Integer;
          // l_c_data_row: DataRow;
          l_c_data_row_view: DataRowView;
      begin
        // -- should use item
        for l_row_index:= 0 to p_c_data_view.Count- 1 do
        begin
          l_c_data_row_view:= p_c_data_view[l_row_index];
          display(f_display_data_row(l_c_data_row_view.Row as DataRow, p_column_count));
        end;

      end; // display_data_view

end.
